/*
 * analog.h
 *
 * Created: 2014-11-21 07:19:53
 *  Author: dsosnowski
 */ 


#ifndef ANALOG_H_
#define ANALOG_H_

//0,1...2,5V
//10mA...250mA, 100mA...2,5A
//40ADC...1000ADC
//10mA = 40
//20mA = 80
//200mA= 800
//250mA= 1000

//100mA= 40
//200mA= 80
//2A   = 800
//2,5A = 1000
 

#define ADC_MAX_VAL				1000	
#define ADC_HSWITCHRANGE_VAL	90		
#define ADC_LSWITCHRANGE_VAL	80
#define ADC_COUNTER_MAX			2
#define ADC_DEFAULT_COMP		0

#define ADC_STATUS_OK			0
#define ADC_READY				1

#define ANALOG_ADC_RES			1024
#define ANALOG_DEFAULT_VREF		2500	//mV
#define ANALOG_DEFAULT_R		100		//mOHM
#define ANALOG_CRANGE0_MULTI	10
#define ANALOG_CBLOCK_MULTI		20
#define ANALOG_VBLOCK_MULTI		10

#define ANALOG_CURR_MAX			5000		//5A
#define ANALOG_VOLTAGE_MAX		25000		//25V
#define POWER_COUNT_MAX			360000		//100h
#define POWER_ACC_CAP_MAX		360000000	//100Ah
#define POWER_ACC_POWER_MAX		3600000000	//1000Wh

#define POWER_PROCESS_IDLE		1
#define POWER_PROCESS_WORK		2
#define POWER_PROCESS_READY		3

#define POWER_PROCESS_START		1
#define POWER_PROCESS_STOP		2

#define AUTOSTOP_ACCEPT_CYCLE	3




void AnalogInit(void);
void AnalogCalib(void);
uint16_t AnalogGet(char channel);
char AnalogProc(void);
void AnalogProcRestart(void);
void AnalogValuesCalc(void);
void PowerCalc(void);
void PowerRestart(void);
char PowerProcess(char action);
char PowerAutoStop(char action);
 

#endif /* ANALOG_H_ */